/*
frshuf.c - Fischer Random Shuffle
Version 0.1.0
Copyright (C) 2004  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

    Free Software Foundation, Inc.
    59 Temple Place - Suite 330
    Boston, MA  02111-1307, USA.
*/
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "frshuf.h"

#define ID_FEN 1
#define ID_LIST 2
#define ID_CHMAST 3

int iFenSw;
int iErrSw,iWait,iExpose;
int cxClient,cyClient;
int cxMiddle,cyMiddle;
int cxChar,cyChar,cxCaps;
char szTitle[128];
static OPENFILENAME ofn;
FRFMT *frshuf;

/*******************************************************************
char szDbg1[80];
char szDbg2[80];
char szDbg3[80];
*******************************************************************/

LRESULT CALLBACK WndProc         (HWND, UINT, WPARAM, LPARAM);
void PopFileInitialize(HWND hwnd);
BOOL PopFileSaveDlg(HWND hwnd, PSTR pstrFileName,
   PSTR pstrTitleName);
BOOL PopFileWrite(HWND hwnd, PSTR pstrFileName);
BOOL PopFenWrite(HWND hwnd, PSTR pstrFileName);
BOOL PopChessMasterWrite(HWND hwnd, PSTR pstrFileName);

static char szAppName[] = "Frshuf";

int WINAPI WinMain (HINSTANCE hInstance,
                    HINSTANCE hPrevInstance,
                    PSTR szCmdLine,
                    int iCmdShow)
   {
   HWND hwnd;
   MSG msg;
   WNDCLASSEX wndclass;

   wndclass.cbSize         = sizeof(wndclass);
   wndclass.style          = CS_HREDRAW | CS_VREDRAW;
   wndclass.lpfnWndProc    = WndProc;
   wndclass.cbClsExtra     = 0;
   wndclass.cbWndExtra     = 0;
   wndclass.hInstance      = hInstance;
   wndclass.hIcon          = LoadIcon (hInstance, szAppName);
   wndclass.hCursor        = LoadCursor (NULL, IDC_ARROW);
   wndclass.hbrBackground  = (HBRUSH)  GetStockObject (WHITE_BRUSH);
   wndclass.lpszMenuName   = szAppName;
   wndclass.lpszClassName  = szAppName;
   wndclass.hIconSm        = LoadIcon (hInstance, szAppName);

   RegisterClassEx (&wndclass);

   hwnd = CreateWindow (szAppName,  // Window Class Name
      "Fischer Random Shuffle",     // Window Caption
      WS_OVERLAPPEDWINDOW,          // Window Style
      60,                           // initial x position
      60,                           // initial y position
      404,                          // initial x size
      250,                          // initial y size
      NULL,                         // parent window handle
      NULL,                         // window menu handle
      hInstance,                    // program instance handle
      NULL);                        // creation parameters

   ShowWindow (hwnd, iCmdShow);
   UpdateWindow (hwnd);

   while (GetMessage (&msg, NULL, 0, 0))
      {
      TranslateMessage (&msg);
      DispatchMessage (&msg);
      } // while (GetMessage (&msg, NULL, 0, 0))

   return msg.wParam;
   } /* WinMain */

LRESULT CALLBACK WndProc (HWND hwnd,
                          UINT iMsg,
                          WPARAM wParam,
                          LPARAM lParam)
   {
   static HINSTANCE hInstance;
   HMENU hMenu;
   TEXTMETRIC tm;
   HDC hdc;
   char szMsg[256];

   switch (iMsg)
      {
      case WM_CREATE:

         {
         int iLength;
         int rslt;
         char *p;
         char szFileName[256];
         char szTitleName[128];
         iLength = GetWindowText(hwnd,szTitle,120);
         hMenu = GetMenu(hwnd);
         CheckMenuItem(hMenu,
            IDM_FEN,MF_CHECKED);
         hdc = GetDC(hwnd);
         GetTextMetrics(hdc,&tm);
         cxChar = tm.tmAveCharWidth;
         cxCaps = (tm.tmPitchAndFamily & 1 ? 3 : 2)
            * (cxChar >> 1);
         cyChar = tm.tmHeight + tm.tmExternalLeading;
         ReleaseDC(hwnd,hdc);
         iWait = iExpose = 0;
         frshuf = (FRFMT *) shuffle();
         if (frshuf == NULL)
            {
            MessageBox(hwnd,
               "Out of memory",
               szAppName,
               MB_ICONERROR | MB_OK);
            iExpose = 1;
            PostMessage(hwnd,WM_CLOSE,0,0L);
            return 0;
            } /* out of memory */
         strcpy(szTitleName,"Fischer Random Shuffle");
         strcpy(szFileName,"*.txt");
         PopFileInitialize(hwnd);
         PopFileSaveDlg(hwnd,szFileName,szTitleName);
         rslt = strcmp(szFileName,"*.txt");
         if (!rslt)
            {
            MessageBox(hwnd,
               "Save file canceled",
               szAppName,
               MB_ICONINFORMATION | MB_OK);
            PostMessage(hwnd,WM_CLOSE,0,0L);
            return 0;
            } /* if cancel */
         p = (char *) szFileName + strlen(szFileName) - 4;
         if (!(rslt = strcmp(p,".fen")))
            {
            PopFenWrite(hwnd,szFileName);
            } /* if create fen file */
         else if (!(rslt = strcmp(p,".cmp")))
            {
            PopChessMasterWrite(hwnd,szFileName);
            } /* if create Chess Master board position */
         else
            {
            PopFileWrite(hwnd,szFileName);
            } /* else create list file */
         sprintf(szMsg,"%s saved",
            szFileName);
         MessageBox(hwnd,
            szMsg,
            szAppName,
            MB_ICONINFORMATION | MB_OK);
         iExpose = iWait = 1;
         free(frshuf);
         PostMessage(hwnd,WM_CLOSE,0,0L);

         return 0;
         } /* create */

      case WM_SIZE:
         cxClient = LOWORD (lParam);
         cyClient = HIWORD (lParam);
         cxMiddle = cxClient >> 1;
         cyMiddle = cyClient >> 1;
         if (iWait)
            {
            iWait = 0;
            InvalidateRect(hwnd,NULL,TRUE);
            } /* if waiting for copyright screen */
         return 0;

      case WM_COMMAND:

         hMenu = GetMenu(hwnd);
         switch (LOWORD (wParam))
            {
            case IDM_EXIT:
               PostMessage(hwnd,WM_CLOSE,0,0L);
               return 0;

            case IDM_FEN:
               iFenSw = 1;
               CheckMenuItem(hMenu,
                  IDM_LIST,MF_UNCHECKED);
               CheckMenuItem(hMenu,
                  IDM_CHMAST,MF_UNCHECKED);
               CheckMenuItem(hMenu,
                  IDM_FEN,MF_CHECKED);
               return TRUE;

            case IDM_LIST:
               iFenSw = 0;
               CheckMenuItem(hMenu,
                  IDM_FEN,MF_UNCHECKED);
               CheckMenuItem(hMenu,
                  IDM_CHMAST,MF_UNCHECKED);
               CheckMenuItem(hMenu,
                  IDM_LIST,MF_CHECKED);
               return TRUE;

            case IDM_CHMAST:
               iFenSw = 0;
               CheckMenuItem(hMenu,
                  IDM_FEN,MF_UNCHECKED);
               CheckMenuItem(hMenu,
                  IDM_LIST,MF_UNCHECKED);
               CheckMenuItem(hMenu,
                  IDM_CHMAST,MF_CHECKED);
               return TRUE;

            case IDM_COPYING:
               { /* copying frshuf */
               int cxOfst,cyOfst;
               char szTemp[128];
               hdc = GetDC(hwnd);

               cxOfst = cxMiddle - (cxChar << 3);
               cyOfst = cyMiddle - cyChar - cyChar;
               sprintf(szTemp, "                               ");
               TextOut(hdc,cxOfst,cyOfst,szTemp,strlen(szTemp));
               cxOfst = cxMiddle - (cxChar << 2);
               cyOfst = cyMiddle;
               sprintf(szTemp, "                               ");
               TextOut(hdc,cxOfst,cyOfst,szTemp,strlen(szTemp));

               cxOfst = cxChar + 4;
               cyOfst = cyMiddle - (cyChar * 4);
               sprintf(szTemp, "frshuf.c Version 0.1.0 "
                  "- Fischer Random Shuffle");
               TextOut(hdc,cxOfst,cyOfst,szTemp,strlen(szTemp));
               cxOfst = cxChar + 4;
               cyOfst = cyMiddle - (cyChar * 3);
               sprintf(szTemp, "Copyright (C) 2004");
               TextOut(hdc,cxOfst,cyOfst,szTemp,strlen(szTemp));
               cxOfst = cxChar + 4;
               cyOfst = cyMiddle - (cyChar * 2);
               sprintf(szTemp, "by dondalah@ripco.com (Dondalah)");
               TextOut(hdc,cxOfst,cyOfst,szTemp,strlen(szTemp));
               cxOfst = cxChar + 4;
               cyOfst = cyMiddle - (cyChar * 1);
               sprintf(szTemp, "frshuf comes with");
               TextOut(hdc,cxOfst,cyOfst,szTemp,strlen(szTemp));
               cxOfst = cxChar + 4;
               cyOfst = cyMiddle - (cyChar * 0);
               sprintf(szTemp, "ABSOLUTELY NO WARRANTY");
               TextOut(hdc,cxOfst,cyOfst,szTemp,strlen(szTemp));
               cxOfst = cxChar + 4;
               cyOfst = cyMiddle + (cyChar * 1);
               sprintf(szTemp, "For details, read the "
                  "GNU General Public License at");
               TextOut(hdc,cxOfst,cyOfst,szTemp,strlen(szTemp));
               cxOfst = cxChar + 4;
               cyOfst = cyMiddle + (cyChar * 2);  
               sprintf(szTemp, "http://www.gnu.org/"
                  "copyleft/gpl.html");
               TextOut(hdc,cxOfst,cyOfst,szTemp,strlen(szTemp));
               cxOfst = cxChar + 4;
               cyOfst = cyMiddle + (cyChar * 3);
               sprintf(szTemp, "Press any key to "
                  "continue.");
               TextOut(hdc,cxOfst,cyOfst,szTemp,strlen(szTemp));
               ReleaseDC(hwnd,hdc);
               iWait = 1;
               } /* copying frshuf */
               return 0;

            case IDM_ABOUT:
               MessageBox(hwnd,
                  "Fischer Random Shuffle 0.1.0",
                  szAppName,
                  MB_ICONINFORMATION | MB_OK);
               iExpose = 1;
               return 0;

            } /* switch (LOWORD (wParam)) */
         break;

      case WM_LBUTTONDOWN:

         if (iWait)
            {
            iWait = 0;
            InvalidateRect(hwnd,NULL,TRUE);
            iExpose = 1;
            } /* if waiting for copy screen */
         else
            {
            PostMessage(hwnd,WM_CLOSE,0,0L);
            } /* not waiting for copy screen */

         return 0;

      case WM_KEYDOWN:

         if (iWait)
            {
            iWait = 0;
            InvalidateRect(hwnd,NULL,TRUE);
            iExpose = 1;
            }

         if (wParam == 'Q')
            {
            PostMessage(hwnd,WM_CLOSE,0,0L);
            } /* if quit */

         return 0;

      case WM_DESTROY:
         PostQuitMessage (0);
         return 0;

      } /* switch (iMsg) */

   return DefWindowProc (hwnd, iMsg, wParam, lParam);
   } /* WndProc */

void PopFileInitialize(HWND hwnd)
   {
   static char szFilter[] = "List files (*.txt)\0*.txt\0" \
                            "FEN files (*.fen)\0*.fen\0" \
                            "Chess Master files (*.cmp)\0*.cmp\0" \
                            "All files (*.*)\0*.*\0\0";

   ofn.lStructSize           = sizeof(OPENFILENAME);
   ofn.hwndOwner             = hwnd;
   ofn.hInstance             = NULL;
   ofn.lpstrFilter           = szFilter;
   ofn.lpstrCustomFilter     = NULL;
   ofn.nMaxCustFilter        = 0;
   ofn.nFilterIndex          = 0;
   ofn.lpstrFile             = NULL;      // set in open/close functions
   ofn.nMaxFile              = _MAX_PATH;
   ofn.lpstrFileTitle        = NULL;      // set in open/close functions
   ofn.nMaxFileTitle         = _MAX_FNAME + _MAX_EXT;
   ofn.lpstrInitialDir       = NULL;
   ofn.lpstrTitle            = NULL;
   ofn.Flags                 = 0;         // set in open/close functions
   ofn.nFileOffset           = 0;
   ofn.nFileExtension        = 0;
   ofn.lpstrDefExt           = "txt";
   ofn.lCustData             = 0L;
   ofn.lpfnHook              = NULL;
   ofn.lpTemplateName        = NULL;
   } /* PopFileInitialize */

BOOL PopFileSaveDlg(HWND hwnd, PSTR pstrFileName,
   PSTR pstrTitleName)
   {
   ofn.hwndOwner             = hwnd;
   ofn.lpstrFile             = pstrFileName;
   ofn.lpstrFileTitle        = pstrTitleName;
   ofn.Flags                 = OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY;
   return GetSaveFileName(&ofn);
   } /* PopFileSaveDlg */

BOOL PopFileWrite(HWND hwnd, PSTR pstrFileName)
   {
   FILE *file;
   int iLength;
   int i;
   int iWrtLen;
   char *p;
   char szBuffer[128];
   file = fopen(pstrFileName,"wt");
   if (file == NULL)
      {
      MessageBox(hwnd,
         "Open Error",
         szAppName,
         MB_ICONERROR | MB_OK);
      return FALSE;
      } /* open error */
   p = (char *) frshuf->game;
   i = 0;
   while (i++ < COMBOS)
      {
      sprintf(szBuffer,"%s\n", p);
      iLength = strlen(szBuffer);
      iWrtLen = (int) fwrite(szBuffer,1,iLength,file);
      if (iWrtLen != iLength)
         {
         MessageBox(hwnd,
            "Write Error",
            szAppName,
            MB_ICONERROR | MB_OK);
         fclose(file);
         return FALSE;
         } /* write err */
      p += WDTH;
      } /* for each game */
   fclose(file);
   return TRUE;
   } /* PopFileWrite */

BOOL PopFenWrite(HWND hwnd, PSTR pstrFileName)
   {
   FILE *file;
   int iLength;
   int i;
   int iWrtLen;
   char *p,*q,*r,*s;
   char szBuffer[128];
   file = fopen(pstrFileName,"wt");
   if (file == NULL)
      {
      MessageBox(hwnd,
         "Open Error",
         szAppName,
         MB_ICONERROR | MB_OK);
      return FALSE;
      } /* open error */
   p = (char *) frshuf->game;
   i = 0;
   while (i++ < COMBOS)
      {
      q = (char *) p;
      r = (char *) q + 8;
      s = (char *) szBuffer;
      while (q < r)
         {
         *s++ = tolower(*q++);
         } /* for each White piece */
      *s = '\0';
      strcat(szBuffer,"/pppppppp/8/8/8/8/PPPPPPPP/");
      strcat(szBuffer,p);
      strcat(szBuffer," w - - 0 1\n");
      iLength = strlen(szBuffer);
      iWrtLen = (int) fwrite(szBuffer,1,iLength,file);
      if (iWrtLen != iLength)
         {
         MessageBox(hwnd,
            "Write Error",
            szAppName,
            MB_ICONERROR | MB_OK);
         fclose(file);
         return FALSE;
         } /* write err */
      p += WDTH;
      } /* for each game */
   fclose(file);
   return TRUE;
   } /* PopFenWrite */

/* Chess Master only accepts one position at a time. */
/* Therefore, only the first game position is saved. */
BOOL PopChessMasterWrite(HWND hwnd, PSTR pstrFileName)
   {
   FILE *file;
   int iLength;
   int iWrtLen;
   char *p,*q,*r;
   char szBuffer[512];
   file = fopen(pstrFileName,"wt");
   if (file == NULL)
      {
      MessageBox(hwnd,
         "Open Error",
         szAppName,
         MB_ICONERROR | MB_OK);
      return FALSE;
      } /* open error */
   p = (char *) frshuf->game;
   q = (char *) p + 8;
   r = (char *) szBuffer;
   while (p < q)
      {
      *r++ = 'B';
      *r++ = *p++;
      *r++ = ' ';
      *r++ = ' ';
      } /* for each Black piece */
   *(r-2) = '\n';
   *(r-1) = '\0';
   strcat(szBuffer,"BP  BP  BP  BP  BP  BP  BP  BP\n");
   strcat(szBuffer,"--  --  --  --  --  --  --  --\n");
   strcat(szBuffer,"--  --  --  --  --  --  --  --\n");
   strcat(szBuffer,"--  --  --  --  --  --  --  --\n");
   strcat(szBuffer,"--  --  --  --  --  --  --  --\n");
   strcat(szBuffer,"WP  WP  WP  WP  WP  WP  WP  WP\n");
   p = (char *) frshuf;
   q = (char *) p + 8;
   r = (char *) szBuffer + strlen(szBuffer);
   while (p < q)
      {
      *r++ = 'W';
      *r++ = *p++;
      *r++ = ' ';
      *r++ = ' ';
      } /* for each White piece */
   *(r-2) = '\n';
   *(r-1) = '\0';
   iLength = strlen(szBuffer);
   iWrtLen = (int) fwrite(szBuffer,1,iLength,file);
   if (iWrtLen != iLength)
      {
      MessageBox(hwnd,
         "Write Error",
         szAppName,
         MB_ICONERROR | MB_OK);
      fclose(file);
      return FALSE;
      } /* write err */
   fclose(file);
   return TRUE;
   } /* PopChessMasterWrite */
